import torch
import os
import pandas as pd
import csv
import json
import numpy as np
import pickle as pkl
from tqdm import tqdm
import argparse
from datetime import datetime, timedelta
"""
def create_new_df(df_discharge, admission_data, microbio, lab_data, prescriptions, diagnoses, diagnoses_d, lab_d, procedures, procedures_d, patients, filename):
	#print(len(df_discharge["TEXT"]))
	#merge all of the needed data by hadm_id and subject id
	df_discharge["HADM_ID"]=df_discharge["HADM_ID"].astype(int) 
	#filtered_discharges=df_discharge[["HADM_ID", "SUBJECT_ID", "CHARTDATE", "CHARTTIME", "TEXT"]].rename(columns={"CHARTDATE": "NOTE_CHARTDATE", "CHARTTIME": "NOTE_CHARTTIME"})
	#filtered_admissions=admission_data[["HADM_ID", "SUBJECT_ID", "ADMITTIME", "DISCHTIME", "DIAGNOSIS", "ETHNICITY"]]
	#print(df_discharge)
	merged_df=admission_data[["HADM_ID", "SUBJECT_ID", "ADMITTIME", "DISCHTIME", "DIAGNOSIS", "ETHNICITY"]].merge(df_discharge[["HADM_ID", "SUBJECT_ID", "CHARTDATE", "CHARTTIME", "TEXT"]].rename(columns={"CHARTDATE": "NOTE_CHARTDATE", "CHARTTIME": "NOTE_CHARTTIME"})
, how="inner", on=["SUBJECT_ID", "HADM_ID"])
	merged_df.drop_duplicates(inplace=True)
	print("New length (should be 52726), added admissions: ", len(list(set(merged_df["HADM_ID"])))) #sanitycheck: True
	#merged_df=admission_data
	#next, add microbiology to the dataframe
	#filtered_microbio=microbio[["HADM_ID", "SUBJECT_ID", "CHARTDATE", "CHARTTIME","SPEC_TYPE_DESC", "ORG_NAME"]].rename(columns={"CHARTDATE": "M_CHARTDATE", "CHARTTIME": "M_CHARTTIME"})
	merged_df=merged_df.merge(microbio[["HADM_ID", "SUBJECT_ID", "CHARTDATE", "CHARTTIME","SPEC_TYPE_DESC", "ORG_NAME"]].rename(columns={"CHARTDATE": "M_CHARTDATE", "CHARTTIME": "M_CHARTTIME"})
, how="inner", on=["SUBJECT_ID", "HADM_ID"])
	print("New length (should be 44301), added microbio: ", len(list(set(merged_df["HADM_ID"])))) 

	#next, add prescriptions to the dataframe
	#filtered_presc=prescriptions[["HADM_ID", "SUBJECT_ID", "STARTDATE", "ENDDATE", "DRUG", "PROD_STRENGTH", "DOSE_VAL_RX", "DOSE_UNIT_RX"]]
	merged_df=merged_df.merge(prescriptions[["HADM_ID", "SUBJECT_ID", "STARTDATE","ENDDATE", "DRUG", "PROD_STRENGTH", "DOSE_VAL_RX", "DOSE_UNIT_RX"]]
 how="inner", on=["SUBJECT_ID", "HADM_ID"])
	print("New length, added prescriptions: ", len(list(set(merged_df["HADM_ID"])))) 
	#merged_df.head()

	#next, add labs to dataframe
	filtered_labs=lab_data[["HADM_ID", "SUBJECT_ID", "CHARTTIME", "ITEMID", "VALUENUM", "VALUEUOM", "FLAG"]].rename(columns={"CHARTTIME": "L_CHARTTIME"})
	i=filtered_labs[filtered_labs["HADM_ID"].apply(lambda v: str(v) == "nan")].index
	filtered_labs=filtered_labs.drop(i) #drop all the nan values from HADM_ID=outpatients (see documentation)
	labs_icd_merge= filtered_labs.merge(lab_d, how="left", on="ITEMID")
	filtered_labs["ITEMID"]=labs_icd_merge["LABEL"]
	i=filtered_labs[filtered_labs["ITEMID"].apply(lambda v: str(v) == "nan")].index
	filtered_labs=filtered_labs.drop(i)
	merged_df=merged_df.merge(filtered_labs, how="inner", on=["SUBJECT_ID", "HADM_ID"])
	print("New length, added labs: ", len(list(set(merged_df["HADM_ID"]))))

	#next, add procedures
	filtered_procedures=procedures[["HADM_ID", "SUBJECT_ID", "ICD9_CODE", "SEQ_NUM"]].rename(columns={"ICD9_CODE": "PROC_ICD9_CODE"})
	procedures_merge=filtered_procedures.merge(procedures_d, how="left", on="ICD9_CODE")
	filtered_procedures["PROC_ICD9_CODE"] =procedures_merge["LONG_TITLE"]
	i=filtered_procedures[filtered_procedures["PROC_ICD9_CODE"].apply(lambda v: str(v) == "nan")].index
	filtered_procedures=filtered_procedures.drop(i)
	merged_df=merged_df.merged(filtered_procedures, how="inner", on=["SUBJECT_ID", "HADM_ID"])
	print("New length, added procedures: ", len(list(set(merged_df["HADM_ID"]))))

	#now, add the diagnoses specific to the hospital stay and the subject
	filtered_diagnoses=diagnoses[["HADM_ID", "SUBJECT_ID","ICD9_CODE"]]
	diagnoses_icd_merge = filtered_diagnoses.merge(diagnoses_d, how="left", on="ICD9_CODE").rename(columns={"ICD9_CODE": "DIAG_ICD9_CODE"})
	filtered_diagnoses["DIAG_ICD9_CODE"] = diagnoses_icd_merge["LONG_TITLE"]
	i=filtered_diagnoses[filtered_diagnoses["DIAG_ICD9_CODE"].apply(lambda v: str(v) == "nan")].index #drop all the not findable diagnoses
	filtered_diagnoses=filtered_diagnoses.drop(i)
	merged_df=merged_df.merged(filtered_diagnoses, how="inner", on=["SUBJECT_ID", "HADM_ID"])
	print("New length, added diagnoses: ", len(list(set(merged_df["HADM_ID"]))))


	#now add static info: gender
	merged_df=merged_df.merge(patients[["SUBJECT_ID", "GENDER"]], how="left", on="SUBJECT_ID")
	print("New length, added gender: ", len(list(set(merged_df["HADM_ID"]))))

	#next, add age
	all_ages=admission_data[["SUBJECT_ID", "DISCHTIME", "HADM_ID"]].merge(patients[["SUBJECT_ID", "DOB"]], how="inner", on="SUBJECT_ID")
	all_ages["DISCHTIME"]=pd.to_datetime(all_ages['DISCHTIME']).dt.date
	all_ages["DOB"] = pd.to_datetime(all_ages['DOB']).dt.date
	age=pd.DataFrame({"AGE": (all_ages.apply(lambda e: (e['DISCHTIME'] - e['DOB']).days/365, axis=1)), "SUBJECT_ID": all_ages["SUBJECT_ID"], "HADM_ID": all_ages["HADM_ID"]})
	merged_df=merged_df.merge(age, how="left", on=["SUBJECT_ID", "HADM_ID"])
	print("New length, added age: ", len(list(set(merged_df["HADM_ID"]))))
	
	print(merged_df.columns)
	merged_df.to_csv(filename)
"""



def create_prompt_list_diagnoses(admission_data, microbio, lab_data, prescriptions, diagnoses, procedures, patients, age, filename, frame=1, classification=False, vector_df=None, icd=False, shortened=False, long_diagnoses=False, from_discharge=False):
	#labdata needs to be cleaneid version: no nans in hadm_id, subject_id column is there and CONCATENATED column contains voncatenated ITEMID (full name), VALUENUM and VALUEUOM, Flag column still contains abnormal/delta/nan-> columns["HADM_ID, ROW_ID, SUBJECT_ID, CHARTTIME, FLAG, CONCATENATED]
	#microbiology_fully_cleaned: [SUBJECT_ID, HADM_ID, ROW_ID, CHARTDATE, CHARTTIME, CONCATENATED]

	data_dict=[]
	#preprocessing steps
	#lab_data.drop(lab_data[lab_data["HADM_ID"].apply(lambda x:str(x) == "nan")].index, inplace=True)
	#lab_data["HADM_ID"]=lab_data["HADM_ID"].astype(int)
	

	#hadm_id_set=list(set(vector_df["HADM_ID"]))
	for stay in tqdm(list(set(diagnoses["HADM_ID"]))): #iterate over all hospital stays that have diagnoses
		prompt="Diagnose: "
		#gold=df_discharge["TEXT"][note_index] #load gold discharge summary #Use this if whole text is gold

		
		#print("TYPE of ds: ", type(gold))
		#subject_id=int(diagnoses["SUBJECT_ID"][stay]) #collect patient id
		#print("SUBJECT ID: ", subject_id)
		hadm_id=int(stay) #collect hospital stay id
		subject_id=diagnoses[diagnoses["HADM_ID"] == hadm_id]["SUBJECT_ID"].values[0]
		print(subject_id)
		
		#print(admission_data[(admission_data["SUBJECT_ID"] == subject_id) & (admission_data["HADM_ID"] == hadm_id)]["DISCHTIME"].astype("datetime64[ns]"))
		if from_discharge ==True:
			admittime_boarder_d=admission_data[(admission_data["SUBJECT_ID"] == subject_id) & (admission_data["HADM_ID"] == hadm_id)]["DISCHTIME"].astype("datetime64[ns]") - pd.DateOffset(days=frame)
		elif from_discharge == False:
			admittime_boarder_d=admission_data[(admission_data["SUBJECT_ID"] == subject_id) & (admission_data["HADM_ID"] == hadm_id)]["ADMITTIME"].astype("datetime64[ns]") + pd.DateOffset(days=frame)

		admittime_boarder=admittime_boarder_d.item()
		#print(admittime_boarder.item())
		if classification == False:
			if icd == False:
				if shortened == False and long_diagnoses == False:
					gold_list=diagnoses[(diagnoses["HADM_ID"]==hadm_id) & (diagnoses["SUBJECT_ID"] == subject_id)].sort_values("SEQ_NUM", ascending=False)["SHORT_TITLE"].to_list()
				elif shortened==True:
					gold_list=list(set(diagnoses[(diagnoses["HADM_ID"]==hadm_id) & (diagnoses["SUBJECT_ID"] == subject_id)].sort_values("SEQ_NUM", ascending=False)["IMPORTANT_WORD"].to_list()))
				elif long_diagnoses==True:
					gold_list=diagnoses[(diagnoses["HADM_ID"]==hadm_id) & (diagnoses["SUBJECT_ID"] == subject_id)].sort_values("SEQ_NUM", ascending=False)["LONG_TITLE"].to_list()
				gold=(", ").join(gold_list)
			else:
				gold_list=diagnoses[(diagnoses["HADM_ID"]==hadm_id) & (diagnoses["SUBJECT_ID"] == subject_id)].sort_values("SEQ_NUM", ascending=False)["ICD9_CODE"].to_list()
				gold=(", ").join(gold_list)
			#print("Gold List: ", gold)
		elif classification == True:
			gold = vector_df[vector_df["HADM_ID"] == hadm_id]["IMPORTANT_WORD_VECTOR"].to_list()
		print(gold)
			
		print("Hadm id: ", hadm_id)
		#First, collect the gender of the patient from the patient table
		gender=patients[patients["SUBJECT_ID"]==subject_id]["GENDER"].item() #Gender is consistently either "M" or "F" in the dataset
		prompt=prompt+gender+"<G>"

		#Then, collect the age from the age table
		subj_age=age[age["HADM_ID"]==hadm_id]["AGE"].item() #age is also consistently an age number (without nan)
		prompt=prompt+str(subj_age)+"<A>"

		#Now, collect the ethnicity of the subject from the admission table
		ethnicity_list=admission_data[admission_data["SUBJECT_ID"]==subject_id]["ETHNICITY"].to_list() #there may be multiple ethnicities
		ethnicity=ethnicity_list[0] #take the 0th value of list 
		prompt=prompt+ethnicity.lower()+"<E>"

		#Next, collect all diagnoses. Admission diagnoses from the admission table, and rest of diagnoses 	
		#this does not really make sense, if we want to assess the models capability to make right diagnosis (sepsis)?
		#specific_diagnoses=diagnoses[(diagnoses["SUBJECT_ID"]==subject_id) & (diagnoses["HADM_ID"]==hadm_id)]["SHORT_TITLE"].to_list()
		#for d in specific_diagnoses:
		#	prompt=prompt+d+" | "
		#prompt=prompt[:-1]
		#prompt=prompt+"<D>"

		#Now, collect all procedures
		specific_procedures=procedures[(procedures["SUBJECT_ID"]==subject_id) & (procedures["HADM_ID"]==hadm_id)]["SHORT_TITLE"].to_list()
		for proc in specific_procedures:
			prompt=prompt+proc+" | "
		if len(specific_procedures) >=1:
			prompt=prompt[:-2]
		prompt=prompt+"<P>"
		
		#Collect medications
		if from_discharge == True:
			if frame >0:
				specific_meds=prescriptions[(prescriptions["SUBJECT_ID"]==subject_id) & (prescriptions["HADM_ID"]==hadm_id) & (prescriptions["STARTDATE"].astype("datetime64[ns]") >= admittime_boarder)]["CONCATENATED"].to_list()
			elif frame ==0:
				specific_meds=prescriptions[(prescriptions["SUBJECT_ID"]==subject_id) & (prescriptions["HADM_ID"]==hadm_id)]["CONCATENATED"].to_list()

		elif from_discharge == False:
			specific_meds=prescriptions[(prescriptions["SUBJECT_ID"]==subject_id) & (prescriptions["HADM_ID"]==hadm_id) & (prescriptions["STARTDATE"].astype("datetime64[ns]") <= admittime_boarder)]["CONCATENATED"].to_list()


		for med in specific_meds:
			prompt=prompt+med+" | "
		if len(specific_meds) >=1: 
			prompt=prompt[:-2]
		prompt=prompt+"<M>"

		#Collect all the microbiology results
		if from_discharge == True:
			if frame >0:
				specific_microbio=microbio[(microbio["SUBJECT_ID"]==subject_id) & (microbio["HADM_ID"]==hadm_id) & (microbio["CHARTTIME"].astype("datetime64[ns]") >= admittime_boarder)]["CONCATENATED"].to_list()
			elif frame ==0:
				specific_microbio=microbio[(microbio["SUBJECT_ID"]==subject_id) & (microbio["HADM_ID"]==hadm_id)]["CONCATENATED"].to_list()

		elif from_discharge == False:
			specific_microbio=microbio[(microbio["SUBJECT_ID"]==subject_id) & (microbio["HADM_ID"]==hadm_id) & (microbio["CHARTTIME"].astype("datetime64[ns]") <= admittime_boarder)]["CONCATENATED"].to_list()

		for m in specific_microbio:
			prompt=prompt+m + " | "
		if len(specific_microbio)>=1:
			prompt=prompt[:-2]
		prompt=prompt+"<T>" 	



		#Then, collect all the labtest that have an abnormal Flag
		#all_subj_hadm_lab=lab_data[(lab_data["SUBJECT_ID"]==subject_id) & (lab_data["HADM_ID"] == hadm_id) & (lab_data["FLAG"]=="abnormal")] #this can be too long for some subjects, and on average (137 abnormal per hospital stay), downsample?
		#joined_values=all_subj_hadm_lab[["ITEMID", "VALUENUM", "VALUEOM"]].astype(str).apply(lambda x: " ".join(x), axis=1)
		if from_discharge == True:
			if frame > 0:
				specific_labs=lab_data[(lab_data["SUBJECT_ID"]==subject_id) & (lab_data["HADM_ID"]==hadm_id) & (lab_data["FLAG"]=="abnormal") & (lab_data["CHARTTIME"].astype("datetime64[ns]") >=admittime_boarder)]["CONCATENATED_WITHOUT_VALUES"].to_list()
			elif frame == 0:
				specific_labs=lab_data[(lab_data["SUBJECT_ID"]==subject_id) & (lab_data["HADM_ID"]==hadm_id) & (lab_data["FLAG"]=="abnormal")]["CONCATENATED_WITHOUT_VALUES"].to_list()

		elif from_discharge == False:
			specific_labs=lab_data[(lab_data["SUBJECT_ID"]==subject_id) & (lab_data["HADM_ID"]==hadm_id) & (lab_data["FLAG"]=="abnormal") & (lab_data["CHARTTIME"].astype("datetime64[ns]") <=admittime_boarder)]["CONCATENATED"].to_list()

		for lab in specific_labs:
			prompt=prompt+lab+ " | "
		if len(specific_labs) >= 1:
			prompt=prompt[:-2]
		prompt=prompt+"<L>" 	
		#print(prompt)
		#print("type of prompt: ", type(prompt))	
		data_dict.append({"prompt": prompt, "label": gold}) #update data_dictionary
	with open(filename, "wb") as f:
		pkl.dump(data_dict, f)
	print("Done!")



def create_prompt_list(df_discharge, admission_data, microbio, lab_data, prescriptions, diagnoses, procedures, patients, age, filename):
	#labdata needs to be cleaned version: no nans in hadm_id, subject_id column is there and CONCATENATED column contains voncatenated ITEMID (full name), VALUENUM and VALUEUOM, Flag column still contains abnormal/delta/nan-> columns["HADM_ID, ROW_ID, SUBJECT_ID, CHARTTIME, FLAG, CONCATENATED]
	#microbiology_fully_cleaned: [SUBJECT_ID, HADM_ID, ROW_ID, CHARTDATE, CHARTTIME, CONCATENATED]

	data_dict=[]
	#preprocessing steps
	#lab_data.drop(lab_data[lab_data["HADM_ID"].apply(lambda x:str(x) == "nan")].index, inplace=True)
	#lab_data["HADM_ID"]=lab_data["HADM_ID"].astype(int)
	


	for note_index in tqdm(range(len(df_discharge["TEXT"]))): #iterate over all discharge letters
		prompt=""
		#gold=df_discharge["TEXT"][note_index] #load gold discharge summary #Use this if whole text is gold

		
		#print("TYPE of ds: ", type(gold))
		subject_id=int(df_discharge["SUBJECT_ID"][note_index]) #collect patient id
		#print("SUBJECT ID: ", subject_id)
		hadm_id=int(df_discharge["HADM_ID"][note_index]) #collect hospital stay id
		#gold_list=diagnoses[diagnoses["HADM_ID"]==hadm_id].sort_values("SEQ_NUM", ascending=False)["SHORT_TITLE"].to_list()
		#gold=(", ").join(gold_list)
		print(gold)
		#print("Hadm id: ", hadm_id)
		#First, collect the gender of the patient from the patient table
		gender=patients[patients["SUBJECT_ID"]==subject_id]["GENDER"].item() #Gender is consistently either "M" or "F" in the dataset
		prompt=prompt+gender+"<G>"

		#Then, collect the age from the age table
		subj_age=age[age["HADM_ID"]==hadm_id]["AGE"].item() #age is also consistently an age number (without nan)
		prompt=prompt+str(subj_age)+"<A>"

		#Now, collect the ethnicity of the subject from the admission table
		ethnicity_list=admission_data[admission_data["SUBJECT_ID"]==subject_id]["ETHNICITY"].to_list() #there may be multiple ethnicities
		ethnicity=ethnicity_list[0] #take the 0th value of list 
		prompt=prompt+ethnicity.lower()+"<E>"

		#Next, collect all diagnoses. Admission diagnoses from the admission table, and rest of diagnoses 	
		#this does not really make sense, if we want to assess the models capability to make right diagnosis (sepsis)?
		#specific_diagnoses=diagnoses[(diagnoses["SUBJECT_ID"]==subject_id) & (diagnoses["HADM_ID"]==hadm_id)]["SHORT_TITLE"].to_list()
		#for d in specific_diagnoses:
		#	prompt=prompt+d+" | "
		#prompt=prompt[:-1]
		#prompt=prompt+"<D>"

		#Now, collect all procedures
		specific_procedures=procedures[(procedures["SUBJECT_ID"]==subject_id) & (procedures["HADM_ID"]==hadm_id)]["SHORT_TITLE"].to_list()
		for proc in specific_procedures:
			prompt=prompt+proc+" | "
		prompt=prompt[:-1]
		prompt=prompt+"<P>"
		
		#Collect medications
		specific_meds=prescriptions[(prescriptions["SUBJECT_ID"]==subject_id) & (prescriptions["HADM_ID"]==hadm_id)]["CONCATENATED"].to_list()
		for med in specific_meds[:4]:
			prompt=prompt+med+" | "
		prompt=prompt[:-1]
		prompt=prompt+"<M>"

		#Collect all the microbiology results
		specific_microbio=microbio[(microbio["SUBJECT_ID"]==subject_id) & (microbio["HADM_ID"]==hadm_id)]["CONCATENATED"].to_list()
		for m in specific_microbio[:11]:
			prompt=prompt+m + " | "
		prompt=prompt[:-1]
		prompt=prompt+"<T>" 	



		#Then, collect all the labtest that have an abnormal Flag
		#all_subj_hadm_lab=lab_data[(lab_data["SUBJECT_ID"]==subject_id) & (lab_data["HADM_ID"] == hadm_id) & (lab_data["FLAG"]=="abnormal")] #this can be too long for some subjects, and on average (137 abnormal per hospital stay), downsample?
		#joined_values=all_subj_hadm_lab[["ITEMID", "VALUENUM", "VALUEOM"]].astype(str).apply(lambda x: " ".join(x), axis=1)
		specific_labs=lab_data[(lab_data["SUBJECT_ID"]==subject_id) & (lab_data["HADM_ID"]==hadm_id) & (lab_data["FLAG"]=="abnormal")]["CONCATENATED"].to_list()
		for lab in specific_labs[:4]:
			prompt=prompt+lab+ " | "
		prompt=prompt[:-1]
		prompt=prompt+"<L>" 	
		#print(prompt)
		#print("type of prompt: ", type(prompt))	
		data_dict.append({"prompt": prompt, "label": gold}) #update data_dictionary
	with open(filename, "wb") as f:
		pkl.dump(data_dict, f)
	print("Done!")

		

if __name__=="__main__":
	parser=argparse.ArgumentParser()
	parser.add_argument("--source_diagnoses", type=str)
	parser.add_argument("--min", type=str)
	args=parser.parse_args()
	
	print("Source Dataset: ", args.source_diagnoses)
	print("Min: ", args.min)
	#print("reading notes")
	#notes_df=pd.read_csv("NOTEEVENTS.csv")
	#df_discharge=pd.read_csv("./5000/train/NOTEEVENTS.csv")	
	#subset_subject=list(set(df_discharge["SUBJECT_ID"]))[:5000]
	#print("reading admissions")
	admission_data=pd.read_csv("./ADMISSIONS.csv")
	#print("reading microbio")
	microbio=pd.read_csv("./10000_diagnoses/train/MICROBIOLOGYEVENTS.csv")
	#print("reading lab data")
	lab_data=pd.read_csv("./10000_diagnoses/train/LABEVENTS_NOT_CONCATENATED.csv")
	print(lab_data.head())
	#print("reading prescriptions")
	prescriptions=pd.read_csv("./10000_diagnoses/train/PRESCRIPTIONS.csv")
	#print("reading diagnoses")
	#diagnoses=pd.read_csv("./10000_diagnoses/test/DIAGNOSES_WITH_LONG_TITLES.csv")
	diagnoses=pd.read_csv(args.source_diagnoses)
	#print("reading diagnoses dict")
	#diagnoses_d=pd.read_csv("D_ICD_DIAGNOSES.csv")
	#print("reading labitems")
	#lab_d=pd.read_csv("D_LABITEMS.csv")
	#print("reading procedures")
	procedures=pd.read_csv("./10000_diagnoses/train/PROCEDURES.csv")
	age=pd.read_csv("./Full_cleaned/age.csv")
	#print("reading procedures dict")
	#procedures_d=pd.read_csv("D_ICD_PROCEDURES.csv")
	#print("reading patients")
	patients=pd.read_csv("./PATIENTS.csv")
	#vectors=pd.read_csv("./diagnosis_classification/IMPORTANT_WORD_VECTORS_MIN_400.csv")
	filename="./10000_diagnoses/train/train_dataset_diagnoses_shortened_min_" + args.min + "labevents_not_concatenated" + ".pkl"
	#create_prompt_list(df_discharge, admission_data, microbio, lab_data, prescriptions, diagnoses, procedures, patients, age, filename)
	create_prompt_list_diagnoses(admission_data, microbio, lab_data, prescriptions, diagnoses, procedures, patients, age, filename, frame=2, classification=False, icd=False, shortened=True, long_diagnoses=True, from_discharge=False)
	print("Done")
	#create_prompt_list_diagnoses(admission_data, microbio, lab_data, prescriptions, diagnoses, procedures, patients, age, filename, classification=True, vector_df=vectors)

	#create_new_df(df_discharge=df_discharge, admission_data=admission_data, microbio=microbio, lab_data=lab_data, prescriptions=prescriptions, diagnoses=diagnoses, diagnoses_d=diagnoses_d, lab_d=lab_d, procedures=procedures, procedures_d=procedures_d, patients=patients, filename=filename)

