#!/bin/bash
#
#SBATCH --job-name=medalpaca
#SBATCH --output=output_train_medalpaca_lora_min_400.txt
#SBATCH --mail-user=kulcsar@cl.uni-heidelberg.de
#SBATCH --mail-type=ALL
#SBATCH --partition=single
#SBATCH --nodes=1
#SBATCH --time=120:00:00
#SBATCH --mem 80G
#SBATCH --gres=gpu:1
#SBATCH --ntasks=1

#JOB STEPS
#srun hostname

#cd /home/students/kulcsar/
#source /home/students/kulcsar/anaconda3/etc/profile.d/conda.sh
#conda activate software_bubble_updated_accelerate

#cd /home/students/kulcsar/Bachelor/for_dataset/10000_diagnoses
#accelerate config
#python -m torch.distributed.launch --nproc_per_node=2 --use_env t5_model.py --model luqh/ClinicalT5-large --tokenizer luqh/ClinicalT5-large --dataset ./dev/dev_dataset_diagnoses_icd_48_pref.pkl --ff --seed 42 --batch_size 8 --epochs 3 --learning_rate 0.000005 --model_save_path t5_small_10000_icd_48_rs42_prefix.pt --do_eval --test_dataset ./test/test_dataset_diagnoses_icd_48_pref.pkl --topk 3 --temp 0.9 --num_beams 4 --no_rep_ngram 2 --do_sample --metrics accuracy --log log_clinicalt5.log

CUDA_LAUNCH_BLOCKING=1 python falcon_model_peft.py --model medalpaca/medalpaca-7b --tokenizer medalpaca/medalpaca-7b --dataset ./train_dataset_diagnoses_shortened_min_400_split.pkl --test_dataset ./test_dataset_diagnoses_shortened_min_400_split.pkl --seed 42 --batch_size 1 --gradient_accumulation_steps 4 --epochs 100 --learning_rate 2e-5 --model_save_path medalpaca_promp_tuned_5_shot.pt 
#--do_eval --test_dataset ./test/test_dataset_diagnoses_48.pkl --topk 30 --temp 0.9 --num_beams 4 --no_rep_ngram 2 --do_sample --metrics accuracy --num_return_sequences 1 


