#!/bin/bash
#
#SBATCH --job-name=t5_small_retrain
#SBATCH --output=output_train_t5_small_10000_min_400_100_epochs.txt
#SBATCH --mail-user=kulcsar@cl.uni-heidelberg.de
#SBATCH --mail-type=ALL
#SBATCH --partition=students
#SBATCH --mem 40G
#SBATCH --gres=gpu:1
#SBATCH --ntasks=1

#JOB STEPS
#srun hostname

cd /home/students/kulcsar/
source /home/students/kulcsar/anaconda3/etc/profile.d/conda.sh
conda activate huggingface_older

cd /home/students/kulcsar/Bachelor/for_dataset/10000_diagnoses
#accelerate config
#python -m torch.distributed.launch --nproc_per_node=2 --use_env t5_model.py --model luqh/ClinicalT5-large --tokenizer luqh/ClinicalT5-large --dataset ./dev/dev_dataset_diagnoses_icd_48_pref.pkl --ff --seed 42 --batch_size 8 --epochs 3 --learning_rate 0.000005 --model_save_path t5_small_10000_icd_48_rs42_prefix.pt --do_eval --test_dataset ./test/test_dataset_diagnoses_icd_48_pref.pkl --topk 3 --temp 0.9 --num_beams 4 --no_rep_ngram 2 --do_sample --metrics accuracy --log log_clinicalt5.log


python t5_model.py --model t5-small --tokenizer t5-small --dataset ./train/train_dataset_diagnoses_48.pkl --seed 42 --batch_size 4 --gradient_accumulation_steps 2 --epochs 100 --learning_rate 0.00005 --model_save_path ./t5_small_10000_diagnoses_48_save_pretrained_100_epochs/ --metrics accuracy --num_return_sequences 1 --num_beams 4 --no_rep_ngram 2 --test_dataset ./test/test_dataset_diagnoses_48.pkl --test_batch_size 4 --config_name t5-small --top_k 3 --temp 0.9 
#--do_eval --test_dataset ./test/test_dataset_diagnoses_48.pkl --topk 30 --temp 0.9 --num_beams 4 --no_rep_ngram 2 --do_sample --metrics accuracy --num_return_sequences 1 
#python t5_model.py --model t5-small --tokenizer t5-small --dataset ./train/train_dataset_diagnoses_shortened_min_10.pkl --seed 42 --batch_size 4 --gradient_accumulation_steps 2 --epochs 3 --learning_rate 0.00005 --model_save_path t5/shortened/t5_small_shortened_10_save_pretrained/ 
#

#python evaluate_model.py -sm t5/shortened/t5_small_shortened_10_save_pretrained -t t5-small -td ./train/train_dataset_diagnoses_shortened_min_10.pkl -b 1 -l eval_log2_icd.log -topk 3 -temp 0.9 -num_beams 4 -no_rep_ngram 2 --config_name t5-small --metrics accuracy precisison



#python t5_model.py --model luqh/ClinicalT5-large --tokenizer luqh/ClinicalT5-large --dataset ./dev/dev_dataset_diagnoses_icd_48.pkl --seed 13 --batch_size 16 --epochs 3 --learning_rate 0.000005 --model_save_path clint5_large_10000_icd_48_rs13.pt --do_eval --test_dataset ./test/test_dataset_diagnoses_48.pkl --topk 3 --temp 0.9 --num_beams 4 --no_rep_ngram 2 -do_sample --metrics accuracy 


#python t5_model.py --model luqh/ClinicalT5-large --tokenizer luqh/ClinicalT5-large --dataset ./dev/dev_dataset_diagnoses_icd_48.pkl --seed 9 --batch_size 16 --epochs 3 --learning_rate 0.000005 --model_save_path clint5_large_10000_icd_48_rs9.pt --do_eval --test_dataset ./test/test_dataset_diagnoses_48.pkl --topk 3 --temp 0.9 --num_beams 4 --no_rep_ngram 2 -do_sample --metrics accuracy 


